unit DataUnit;
{< 

    Rapida (  )@br
  2011}

interface

uses
  SysUtils, Classes, Contnrs, xmldom, XMLIntf, msxmldom, XMLDoc, Forms, Variants, IdIOHandler, IdIOHandlerSocket, IdIOHandlerStack,
  IdSSL, IdSSLOpenSSL, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP, Controls, ComCtrls, IdURI;

type
  // 
  TDMod = class(TDataModule)
    HTTPS: TIdHTTP;
    SSLIOHandler: TIdSSLIOHandlerSocketOpenSSL;
    XMLDoc: TXMLDocument;
    procedure SSLIOHandlerGetPassword(var Password: String);
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
  private
    FPPoint: AnsiString;
    FHost: AnsiString;
    FCertificate: AnsiString;
    FPassword: AnsiString;
    FFeeList: TStringList;
    procedure SetCertificate(const value: AnsiString);
  public
    //     ,        ,       
    property PPoint: AnsiString read FPPoint write FPPoint;
    //http ,   ,    = https://tqpay.rapida.ru/test @br
    //              ( ) = https://qpay.rapida.ru/gate
    property Host: AnsiString read FHost write FHost;
    //   X.509      @br
    //  ".cer"     ".key"  
    property Certificate: AnsiString read FCertificate write SetCertificate;
    // 
    property Password: AnsiString read FPassword write FPassword;
    //   ,     
    property FeeList: TStringList read FFeeList write FFeeList;
    //  
    procedure SetProxy(Use: boolean; const Server: AnsiString = ''; Port: integer = 0; const UserName: AnsiString = ''; const Password: AnsiString = '');
    //GET   
    function HTTPSGet(const Path, Params: AnsiString): AnsiString;
    //POST   .       .     .
    function HTTPSPost(const Path, Params, FormParams: AnsiString): AnsiString;
    //    
    procedure TestConnect;
    //   (  ,       )
    function GetBalance: AnsiString;
    //      
    procedure GetFee(trvTsp: TTreeView);
    //  ID  (  ,     )
    function PaymExtIdGen: AnsiString;
    //   
    procedure Check(const ExtId, TSPCode, Params: AnsiString; Amount, FeeS, FeeA: integer);
    //  (        "")
    procedure Payment(const ExtId, TSPCode, Params: AnsiString; Amount, FeeS, FeeA: integer);
    // ...       (/Utc + ...  )
    function GetInfo(const ExtId, TSPCode, Params: AnsiString; Amount, FeeS, FeeA: integer): AnsiString;
  end;

  // , ,  , ,  , 
  TFeeRec = record
    fix, perc, min, max, minsum, maxsum: Extended;
  end;

  //  / , 
  TFee = class
    agt: TFeeRec;
    sys: TFeeRec;
  end;

var
  DMod: TDMod;

implementation

uses FormUnit;

{$R *.dfm}

{ ---------------------------------------- }

procedure FreeFee(List: TStringList);
//    
var
  i: integer;
begin
  with List do
    for i:= 0 to Count - 1 do begin
      Objects[i].Free;
      Objects[i]:= nil;  
    end;
end;

procedure TDMod.DataModuleCreate(Sender: TObject);
begin
  FFeeList:= TStringList.Create;
  FFeeList.Sorted    := true;
  FFeeList.Duplicates:= dupIgnore; //    ,  ...
end;

procedure TDMod.DataModuleDestroy(Sender: TObject);
begin
  FreeFee(FFeeList);
  FFeeList.Free;
end;

{ ---------------------------------------- }

procedure TDMod.SetCertificate(const value: AnsiString);
//    
var
  ProgPath: AnsiString;
begin
  ProgPath:= ExtractFilePath(Application.ExeName);

  //if not FileExists(ProgPath + 'Rapida.pem') then //    ,    
  //  raise Exception.Create('      : "Rapida.pem".');

  if not FileExists(ProgPath + value + '.cer') then
    raise Exception.Create('     : "' +value+ '.cer".');

  if not FileExists(ProgPath + value + '.key') then
    raise Exception.Create('      : "' +value+ '.key".');

  FCertificate:= value;
  with SSLIOHandler.SSLOptions do begin
    //RootCertFile:= ProgPath + 'Rapida.pem'; //  ,    ...
    CertFile    := ProgPath + FCertificate + '.cer';
    KeyFile     := ProgPath + FCertificate + '.key';
  end;
end;

procedure TDMod.SetProxy(Use: boolean; const Server: AnsiString = ''; Port: integer = 0; const UserName: AnsiString = ''; const Password: AnsiString = '');
//  
begin
  with HTTPS.ProxyParams do begin
    BasicAuthentication:= true;
    if Use then begin
      ProxyServer  := Server;
      ProxyPort    := Port;
      ProxyUsername:= UserName;
      ProxyPassword:= Password;
    end else begin
      ProxyServer  := ''; //   ,   ,   
      ProxyPort    := 0;
      ProxyUsername:= '';
      ProxyPassword:= '';
    end;
  end;
end;

function URLEncode(const ASrc: AnsiString): AnsiString;
//  Indy  ,   ...
//   Indy TIdURI.URLEncode   ,       cp1251
const
  UnsafeChars = '*#%<>+[]';
var
  i: Integer;
begin
  result:= '';

  for i:= 1 to Length(ASrc) do begin
    if (Pos(ASrc[i], UnsafeChars) > 0) or (ASrc[i] >= #$80) or (ASrc[i] <= #32) then begin
      result:= result + '%' + IntToHex(Ord(ASrc[i]), 2);
    end else begin
      result:= result + ASrc[i];
    end;
  end;
end;

function TDMod.HTTPSGet(const Path, Params: AnsiString): AnsiString;
//GET   
var
  url: string;
  OutStream: TStringStream;
begin
  try
    if Path <> ''
      then url:= Path + Params
      else url:= Host + Params;

    ShowForm.memRequest.Text:= url;
    ShowForm.memReply.Text  := '';  //   ,   
    Application.ProcessMessages;

    OutStream:= TStringStream.Create('');
    try
      HTTPS.Get(URLEncode(url), OutStream);
      result:= OutStream.DataString;
    finally
      OutStream.Free;
    end;
  finally
    HTTPS.Disconnect;
  end;

  ShowForm.memReply.Text:= result;
end;

function TDMod.HTTPSPost(const Path, Params, FormParams: AnsiString): AnsiString;
//POST   
var
  url: string;
  OutStream, PostStream: TStringStream;
begin
  try
    if Path <> ''
      then url:= Path + Params
      else url:= Host + Params;

    ShowForm.memRequest.Text:= url +#13#10+ FormParams;
    ShowForm.memReply.Text  := '';  //   ,   
    Application.ProcessMessages;

    OutStream:= TStringStream.Create('');
    try
      PostStream:= TStringStream.Create(FormParams);
      try
        HTTPS.Post(TIdURI.URLEncode(url), PostStream, OutStream);
      finally
        PostStream.Free;
      end;
      result:= OutStream.DataString;
    finally
      OutStream.Free;
    end;
  finally
    HTTPS.Disconnect;
  end;

  ShowForm.memReply.Text:= result;
end;

{ ---------------------------------------- }

procedure TDMod.SSLIOHandlerGetPassword(var Password: AnsiString);
//   
begin
  Password:= FPassword;
end;

{ ---------------------------------------- }

function NodeText(Node: IXMLNode): AnsiString;
begin
  if Node <> nil
    then result:= VarToStr(Node.Text)
    else result:= '';
end;

function CheckUpAndGetRoot(XML: TXMLDocument; const Sign, Text: AnsiString): IXMLNode;
// xml         OK  
var
  Node: IXMLNode;
begin
  XML.XML.Text:= Text;
  XML.Active  := true;

  result:= XML.ChildNodes.FindNode('Response');
  if result = nil then
    raise Exception.Create('   (' +Sign+ ').    Xml.');

  Node:= result.ChildNodes.FindNode('Result');
  if Node = nil then
    raise Exception.Create('   (' +Sign+ ').   Result.');

  if UpperCase(NodeText(Node)) <> 'OK' then begin
    Node:= result.ChildNodes.FindNode('Description');
    if Node = nil then
      raise Exception.Create('   (' +Sign+ ').    Description.');

    raise Exception.Create(NodeText(Node));
  end;
end;

procedure TDMod.TestConnect;
//    
var
  st: AnsiString;
begin
  screen.Cursor:= crHourGlass;
  try
    st:= Trim(HTTPSGet('https://tepay.rapida.ru', ''));  //     
    if st <> 'Test!' then                                //    
      raise Exception.Create(st);                        //   (  - HTTP OK 200,     /,    )
  finally
    screen.Cursor:= crDefault;
  end;
end;

function TDMod.GetBalance: AnsiString;
//  
var
  Root, Node: IXMLNode;
begin
  screen.Cursor:= crHourGlass;
  try
    result:= ' ...';

    Root:= CheckUpAndGetRoot(
      XMLDoc,
      'GetBalance',
      HTTPSGet('', '?function=getbalance&PaymExtId='+PPoint+'.RequestBalance') //PaymExtId   ,     ,
    );                                                                         //      ...    
                                                                               //   .      

    Node:= Root.ChildNodes.FindNode('Data');
    if Node = nil then
      raise Exception.Create('   (GetBalance).   Data.');

    Node:= Node.ChildNodes.FindNode('Balance');
    if Node = nil then
      raise Exception.Create('   (Balance).   Balance.');

    result:= NodeText(Node);
  finally
    screen.Cursor:= crDefault;
  end;
end;

procedure TDMod.GetFee(trvTsp: TTreeView);
//      
var
  Root, Node, TmpNode, TmpNode2: IXMLNode;
  i, Index: integer;
  Fee: TFee;

  procedure AddBranch(Node: IXMLNode; TrNode: TTreeNode);
  var
    i: integer;
    TmpNode: IXMLNode;
    sName: AnsiString;

    function NameToIndex(const sName: AnsiString): integer;
    begin
      if sName = 'part' then result:= 0
      else if sName = 'tsp' then result:= 1
           else if sName = 'field' then result:= 2
                else result:= -1;
    end;

    function GetFullName(const sName: AnsiString; const sDest: AnsiString = ''; const sNote: AnsiString = ''): AnsiString;
    begin
      result:= ' ' + sName;
      if sDest <> '' then result:= result + ' - ' + sDest;
      if sNote <> '' then result:= result + ' (' + sNote + ')';
    end;

  begin
    for i:= 0 to Node.ChildNodes.Count - 1 do begin
      TmpNode:= Node.ChildNodes.Nodes[i];

      Index:= NameToIndex(TmpNode.LocalName);
      if Index = -1 then Continue; // 

      sName:= VarToStr(TmpNode.Attributes['name']);

      case Index of
        0: //part
          AddBranch(
            TmpNode,
            trvTsp.Items.AddChildObject(TrNode, GetFullName(sName), nil)
          );
        1: //tsp
          if StrToIntDef(VarToStr(TmpNode.Attributes['type']), 0) <> 2 then //     , 
            AddBranch(
              TmpNode,
              trvTsp.Items.AddChildObject(
                TrNode,
                GetFullName(
                  sName,
                  VarToStr(TmpNode.Attributes['dest']),
                  VarToStr(TmpNode.Attributes['note'])
                ),
                Pointer(StrToIntDef(VarToStr(TmpNode.Attributes['code']), 0))
              )  
            );
        2: //field
          AddBranch(
            TmpNode,
            trvTsp.Items.AddChildObject(
              TrNode,
              GetFullName(sName),
              Pointer(StrToIntDef(VarToStr(TmpNode.Attributes['code']), 0))
            )
          );
      end;
    end;
  end;

begin
  screen.Cursor:= crHourGlass;
  try
    XMLDoc.XML.Text:= HTTPSGet('', '?function=getfee');

    Application.ProcessMessages; //   "" 
    XMLDoc.Active  := true;

    Root:= XMLDoc.ChildNodes.FindNode('rapida');                       //xml    .     
    if Root = nil then begin                                           //   root  rapida,    ...
      Root:= XMLDoc.ChildNodes.FindNode('Response');                   //     xml
      if Root = nil then
        raise Exception.Create('   (GetFee).    Xml.');

      Node:= Root.ChildNodes.FindNode('Description');
      if Node = nil then
        raise Exception.Create('   (GetFee).   Description.');

      raise Exception.Create(NodeText(Node));
    end;
    Node:= Root.ChildNodes.FindNode('fee');                         //  "",     
    if Node = nil then
      raise Exception.Create('   (GetFee).   fee.');

    try                                                            //   
                                                                   //       ,   
      FFeeList.BeginUpdate;
      FreeFee(FFeeList);
      FFeeList.Clear;

      for i:= 0 to Node.ChildNodes.Count - 1 do begin
        TmpNode:= Node.ChildNodes.Nodes[i];

        if TmpNode.LocalName <> 'ffield' then Continue;            // ""    

        Fee:= TFee.Create;
        with Fee.agt do begin                                      // ,       ,
                                                                   //   ,   
          fix   := StrToFloatDef(VarToStr(TmpNode.Attributes['fix'   ]), 0);
          perc  := StrToFloatDef(VarToStr(TmpNode.Attributes['perc'  ]), 0);
          min   := StrToFloatDef(VarToStr(TmpNode.Attributes['min'   ]), 0);
          max   := StrToFloatDef(VarToStr(TmpNode.Attributes['max'   ]), 0);
          minsum:= StrToFloatDef(VarToStr(TmpNode.Attributes['minsum']), 0);
          maxsum:= StrToFloatDef(VarToStr(TmpNode.Attributes['maxsum']), 0);
        end;
        TmpNode2:= TmpNode.ChildNodes.FindNode('sys');
        if TmpNode2 <> nil then
          with Fee.sys do begin                                    // ,    ... ( ,    )
                                                                   //   ,      
                                                                   //         
                                                                   //     
            fix   := StrToFloatDef(VarToStr(TmpNode2.Attributes['fix'   ]), 0);
            perc  := StrToFloatDef(VarToStr(TmpNode2.Attributes['perc'  ]), 0);
            min   := StrToFloatDef(VarToStr(TmpNode2.Attributes['min'   ]), 0);
            max   := StrToFloatDef(VarToStr(TmpNode2.Attributes['max'   ]), 0);
            minsum:= StrToFloatDef(VarToStr(TmpNode2.Attributes['minsum']), 0);
            maxsum:= StrToFloatDef(VarToStr(TmpNode2.Attributes['maxsum']), 0);
          end;

        FFeeList.AddObject(VarToStr(TmpNode.Attributes['code']), Fee);
      end;
    finally
      FFeeList.EndUpdate;
    end;

    try
      trvTsp.Items.BeginUpdate;
      trvTsp.Items.Clear;

      AddBranch(Root, nil)
    finally
      trvTsp.Items.EndUpdate;
    end;
  finally
    screen.Cursor:= crDefault;
  end;
end;

function TDMod.PaymExtIdGen: AnsiString;
//  ID  (  ,      +  )
var
  GUID: TGUID;
begin
  CreateGUID(GUID);
  result:= PPoint +'.'+ StringReplace(Copy(GuidToString(GUID), 2, 36), '-', '', [rfReplaceAll]); // ...      (         = )
  result:= Copy(result, 1, 20); //20   ;(
end;

function IntToStr3(val: integer): AnsiString;
begin
  result:= IntToStr(val);
  if length(result) < 3 then begin
    result:= '0' + result;
    if length(result) < 3 then
      result:= '0' + result;
  end;
end;

procedure TDMod.Check(const ExtId, TSPCode, Params: AnsiString; Amount, FeeS, FeeA: integer);
//   
var
  TermType: AnsiString;
begin
  screen.Cursor:= crHourGlass;
  try
    if FeeA = 0
      then TermType:= '001-10'  //  
      else TermType:= '001-09'; //

    //https://tqpay.rapida.ru/test/?function=check&PaymExtId=R101755101.DOT3.310&PaymSubjTp=400&Amount=1000&Params=11 4954625794;220 19;509 ;221 &TermType=001-10&TermId=DOT3&FeeSum=000&FeeS=000&FeeA=000&client=PM2.5.0.145(1.5.0.116)
    HTTPSGet('', '?function=check&PaymExtId='  +ExtId+
                                '&PaymSubjTp=' +TSPCode+
                                '&Amount='     +IntToStr3(Amount)+
                                '&Params='     +Params+
                                '&TermType='   +TermType+
                                '&TermId='     +PPoint+
                                '&FeeSum='     +IntToStr3(FeeA + FeeS)+
                                '&FeeA='       +IntToStr3(FeeA)+
                                '&FeeS='       +IntToStr3(FeeS)+
                                '&client='     +'test 0.1'
            );
  finally
    screen.Cursor:= crDefault;
  end;
end;

procedure TDMod.Payment(const ExtId, TSPCode, Params: AnsiString; Amount, FeeS, FeeA: integer);
//  (        "")
var
  TermType: AnsiString;
begin
  screen.Cursor:= crHourGlass;
  try
    if FeeA = 0
      then TermType:= '001-10'  //  
      else TermType:= '001-09'; //

    //https://tqpay.rapida.ru/test/?function=payment&PaymExtId=R101755101.DOT3.310&PaymSubjTp=400&Amount=1000&Params=11 4954625794;220 19;509 ;221 &TermType=001-10&TermId=DOT3&TermTime=20171017T115543+0300&FeeSum=000&FeeS=000&FeeA=000&client=PM2.5.0.145(1.5.0.116)
    HTTPSGet('', '?function=payment&PaymExtId=' +ExtId+
                                '&PaymSubjTp='  +TSPCode+
                                '&Amount='      +IntToStr3(Amount)+
                                '&Params='      +Params+
                                '&TermType='    +TermType+
                                '&TermId='      +PPoint+
                                '&FeeSum='      +IntToStr3(FeeA + FeeS)+
                                '&FeeA='        +IntToStr3(FeeA)+
                                '&FeeS='        +IntToStr3(FeeS)+
                                '&client='      +'test 0.1'
             );
  finally
    screen.Cursor:= crDefault;
  end;
end;

function TDMod.GetInfo(const ExtId, TSPCode, Params: AnsiString; Amount, FeeS, FeeA: integer): AnsiString;
// ...       (/Utc + ...  )
var
  TermType: AnsiString;
  Root, Node: IXMLNode;

begin
  screen.Cursor:= crHourGlass;
  try
    result:= ' ...';

    TermType:= '001-10';

    Root:= CheckUpAndGetRoot(
      XMLDoc,
      'GetInfo',
      HTTPSGet('', '?function=getinfo&PaymExtId='  +PPoint+'.'+ExtId+       //  chec/payment   ...
                                    '&PaymSubjTp=' +TSPCode+
                                    '&Amount='     +IntToStr3(Amount)+
                                    '&Params='     +Params+
                                    '&TermType='   +TermType+
                                    '&TermId='     +PPoint+
                                    '&FeeSum='     +IntToStr3(FeeA + FeeS)+
                                    '&FeeA='       +IntToStr3(FeeA)+
                                    '&FeeS='       +IntToStr3(FeeS)
              )
    );

    Node:= Root.ChildNodes.FindNode('Description');
    if Node = nil then
      raise Exception.Create('   (GetInfo).   Description.');

    result:= NodeText(Node);
  finally
    screen.Cursor:= crDefault;
  end;
end;

end.
