unit FormUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, Math;

type
  TShowForm = class(TForm)
    butTest: TButton;
    splMain: TSplitter;
    pnlLeft: TPanel;
    splServer: TSplitter;
    pnlReply: TPanel;
    lblReply: TLabel;
    memReply: TRichEdit;
    pnlRequest: TPanel;
    lblRequest: TLabel;
    memRequest: TRichEdit;
    butGetBalance: TButton;
    butGetTSP: TButton;
    trvTsp: TTreeView;
    pageControl: TPageControl;
    tabSheetMess: TTabSheet;
    tabSheetPayment: TTabSheet;
    lblTSPName: TLabel;
    edPar1: TLabeledEdit;
    edPar2: TLabeledEdit;
    edPar3: TLabeledEdit;
    edPar4: TLabeledEdit;
    edPar5: TLabeledEdit;
    edPar6: TLabeledEdit;
    edPar7: TLabeledEdit;
    edPar8: TLabeledEdit;
    edPar9: TLabeledEdit;
    edPar10: TLabeledEdit;
    edAFix: TLabeledEdit;
    edAPerc: TLabeledEdit;
    edAMin: TLabeledEdit;
    edAMax: TLabeledEdit;
    edAMinsum: TLabeledEdit;
    edAMaxsum: TLabeledEdit;
    edSFix: TLabeledEdit;
    edSPerc: TLabeledEdit;
    edSMin: TLabeledEdit;
    edSMax: TLabeledEdit;
    edSMinsum: TLabeledEdit;
    edSMaxsum: TLabeledEdit;
    edPay: TLabeledEdit;
    edSum: TLabeledEdit;
    butCheck: TButton;
    butPaymant: TButton;
    edPaymExtId: TLabeledEdit;
    butGetInfo: TButton;
    procedure FormCreate(Sender: TObject);
    procedure butTestClick(Sender: TObject);
    procedure butGetBalanceClick(Sender: TObject);
    procedure butGetTSPClick(Sender: TObject);
    procedure trvTspEnter(Sender: TObject);
    procedure trvTspChanging(Sender: TObject; Node: TTreeNode;  var AllowChange: Boolean);
    procedure butCheckClick(Sender: TObject);
    procedure butPaymantClick(Sender: TObject);
    procedure edPayChange(Sender: TObject);
    procedure butGetInfoClick(Sender: TObject);
  private
    TSPCode: AnsiString;
    function ParByInd(ind: integer): TLabeledEdit;
    function MakeParams: AnsiString;
  public
  end;

var
  ShowForm: TShowForm;

implementation

uses DataUnit;

{$R *.dfm}

procedure TShowForm.FormCreate(Sender: TObject);
begin
  // 
  with DMod do begin
    SetProxy(false);                               // 
    //SetProxy(true, 'proxy.int.rapida.ru', 3128);   //  ,  /  

    PPoint     := 'DOT3';                           //  
    Host       := 'https://tqpay.rapida.ru/test/';  //    url

    Certificate:= 'TestCertificate';                // 
    Password   := '12345';                          //  
  end;
  butTest.Enabled:= true;
end;

procedure TShowForm.butTestClick(Sender: TObject);
begin
  DMod.TestConnect;                                //   ,   ...
                                                   //    

  butGetBalance.Enabled:= true;
  butGetTSP.Enabled    := true;
end;

procedure TShowForm.butGetBalanceClick(Sender: TObject);
begin
  ShowMessage('   = "' +DMod.GetBalance+ '".');
end;

procedure TShowForm.butGetTSPClick(Sender: TObject);
begin
  DMod.GetFee(trvTsp);                             //   ... ..   ,    " "    ...
                                                   //   /     / .
  trvTsp.Enabled:= true;
  tabSheetPayment.TabVisible:= true;
end;

procedure TShowForm.trvTspEnter(Sender: TObject);
begin
  pageControl.ActivePage:= tabSheetPayment;
end;

function TShowForm.ParByInd(ind: integer): TLabeledEdit;
begin
  case ind of
    0: result:= edPar1;
    1: result:= edPar2;
    2: result:= edPar3;
    3: result:= edPar4;
    4: result:= edPar5;
    5: result:= edPar6;
    6: result:= edPar7;
    7: result:= edPar8;
    8: result:= edPar9;
    9: result:= edPar10;
    else
      raise Exception.Create('       - ' + IntToStr(ind) + '.');
  end;
end;

procedure TShowForm.trvTspChanging(Sender: TObject; Node: TTreeNode; var AllowChange: Boolean);
var
  i, Code: integer;
  edPar: TLabeledEdit;

  procedure InitParamsInput;
  var
    i: integer;

    procedure InitOne(edPar: TLabeledEdit);
    begin
      with edPar do begin
        EditLabel.Caption:= '<None>';
        Text:= '';
        Hint:= '';
        Enabled:= false;
      end;
    end;

  begin
    for i:= 0 to 9 do InitOne(ParByInd(i));
  end;

  procedure FillEdFee(Fee: TFee);
  begin
    if Fee = nil then begin
      edAFix.Text:= '0.0'; edAPerc.Text:= '0.0'; edAMin.Text:= '0.0'; edAMax.Text:= '0.0'; edAMinsum.Text:= '0.0'; edAMaxsum.Text:= '0.0';
      edSFix.Text:= '0.0'; edSPerc.Text:= '0.0'; edSMin.Text:= '0.0'; edSMax.Text:= '0.0'; edSMinsum.Text:= '0.0'; edSMaxsum.Text:= '0.0';
    end else begin
      with Fee.agt do begin
        edAFix.Text   := FloatToStr(fix);
        edAPerc.Text  := FloatToStr(perc);
        edAMin.Text   := FloatToStr(min);
        edAMax.Text   := FloatToStr(max);
        edAMinsum.Text:= FloatToStr(minsum);
        edAMaxsum.Text:= FloatToStr(maxsum);
      end;
      with Fee.sys do begin
        edSFix.Text   := FloatToStr(fix);
        edSPerc.Text  := FloatToStr(perc);
        edSMin.Text   := FloatToStr(min);
        edSMax.Text   := FloatToStr(max);
        edSMinsum.Text:= FloatToStr(minsum);
        edSMaxsum.Text:= FloatToStr(maxsum);
      end;
    end;
  end;

begin
  Code:= integer(Node.Data);
  if Code <> 0 then
    if Node.HasChildren then begin
      TSPCode:= IntToStr(Code); //     

      lblTSPName.Caption:= Node.Text;
      InitParamsInput;

      for i:= 0 to Node.Count-1 do
        with Node.Item[i] do begin
          edPar     := ParByInd(i);
          edPar.Hint:= IntToStr(integer(Data));
          edPar.EditLabel.Caption:= Text + ' (' +edPar.Hint+ ')';
          edPar.Enabled:= true;
        end;

      i:= DMod.FeeList.IndexOf(IntToStr(Code));
      if i <> -1
        then FillEdFee(TFee(DMod.FeeList.Objects[i]))
        else FillEdFee(nil);

      butCheck.Enabled  := true;
      butPaymant.Enabled:= true;
      butGetInfo.Enabled:= true;
    end;
end;

procedure TShowForm.edPayChange(Sender: TObject);
begin
  edSum.Text:= '';
end;


function TShowForm.MakeParams: AnsiString;
var
  i: integer;
begin
  result:= '';

  for i:= 0 to 9 do
    with ParByInd(i) do begin
      if not Enabled then break;

      result:= result + Hint + ' ' + Text + ';'
    end;

  SetLength(result, Length(result)-1);
end;

procedure TShowForm.butCheckClick(Sender: TObject);
var
  Amount, FeeS, FeeA: Extended;
begin
  edPaymExtId.Text:= DMod.PaymExtIdGen; //Check     ,

  Amount:= StrToFloatDef(edPay.Text, 0);
  FeeA  := Amount * (1 + StrToFloatDef(edAPerc.Text, 0) / 100) - Amount; //  (  )
  FeeS  := Amount * (1 + StrToFloatDef(edSPerc.Text, 0) / 100) - Amount; //  (  )
  edSum.Text:= FloatToStr((Amount + FeeA + FeeS));
  DMod.Check(Trim(edPaymExtId.Text), TSPCode, MakeParams(), Round(Amount * 100), Round(FeeA * 100), Round(FeeS * 100));

  pageControl.ActivePage:= tabSheetMess;
end;

procedure TShowForm.butPaymantClick(Sender: TObject);
var
  Amount, FeeS, FeeA: Extended;
begin
  if Trim(edPaymExtId.Text) = '' then     //Paymant    ,   Check-     
    edPaymExtId.Text:= DMod.PaymExtIdGen; //(  ,       )
                                          // " "     

  Amount:= StrToFloatDef(edPay.Text, 0);
  FeeA  := Amount * (1 + StrToFloatDef(edAPerc.Text, 0) / 100) - Amount; //  (  )
  FeeS  := Amount * (1 + StrToFloatDef(edSPerc.Text, 0) / 100) - Amount; //  (  )
  edSum.Text:= FloatToStr((Amount + FeeA + FeeS));
  DMod.Payment(Trim(edPaymExtId.Text), TSPCode, MakeParams(), Round(Amount * 100), Round(FeeA * 100), Round(FeeS * 100));

  pageControl.ActivePage:= tabSheetMess;
end;

procedure TShowForm.butGetInfoClick(Sender: TObject);
begin
  ShowMessage('    = "'+
    DMod.GetInfo('UserBalance', TSPCode, MakeParams(), 0, 0, 0) //           Utc,     ...
  +'".');

  pageControl.ActivePage:= tabSheetMess;
end;

end.
